<?php defined('SYSPATH') or die('No direct script access.');
class Admin_Model extends Model
{
	public function __construct()
	{	
		parent::__construct();
		$this->db = new Database();
		$this->session = Session::instance();
		$this->user_id = $this->session->get("user_id");	
	}
	
	/** ADMIN HOME DASHBOARD DATA COUNT **/
	
	public function get_admin_dashboard_data()
	{	
			
		$result_active_products = $this->db->query("SELECT * FROM product WHERE purchase_count < user_limit_quantity and deal_status = 1 ");
		$result["active_products"]=count($result_active_products);
		
		$result_sold_products =$this->db->query("SELECT * FROM product WHERE purchase_count = user_limit_quantity and deal_status = 1 ");
		$result["archive_products"]=count($result_sold_products);

		$result_users = $this->db->from("users")->join("city","city.city_id","users.city_id")->join("country","country.country_id","users.country_id")->where(array("user_type" => 4, "user_status" => 1)) ->get();
            	$result["users"] =count($result_users);

		$result["admin"] = $this->db->count_records("users", array( "user_type" => 1, "user_status" => 1));
		$result_city = $this->db->from("city")->join("country","country.country_id","city.country_id")->where(array("city_status" => 1,"country.country_status" => 1))->get();
		$result["city"] = count($result_city);

		$result["county"] = $this->db->count_records("country", array( "country_status" => 1));

		$result["fund"] = $this->db->count_records("request_fund", array("type" => 1));

		$result["blog"] = $this->db->count_records("blog", array( "blog_status" => 1));



		$result["category"] = $this->db->count_records("category", array("category_status" => 1));

		$result_category = $this->db->from("category")->join("category_mapping","category_mapping.map_main_category_id","category.category_id")->where(array("category_status" => 1))->get();
                $result["category"] =count($result_category);

		$result["FAQ"] = $this->db->count_records("faq", array( "faq_status" => 1));
		$result["contact"] = $this->db->count_records("contact", array( "status" => 1));

		$result_subscribe = $this->db->from("email_subscribe")->join("city","city.city_id","email_subscribe.city_id")->where(array("is_deleted" => 0,"suscribe_status"=>1))->get();
                $result["subscribe"] =count($result_subscribe);

		$result["products_shipping"] = count($this->db->select("shipping_info.shipping_id")->from("shipping_info")->join("transaction","transaction.id","shipping_info.transaction_id")->join("product","product.deal_id","transaction.product_id")->where(array( "shipping_type" => 1,"transaction.type !=" =>5))->groupby("shipping_id")->get());

		return $result;
	}
	
	/** GET ADMIN BALANCE **/
	
	public function get_admin_balance()
	{
                $result =$this->db->from("users")->where(array("user_type" => 1, "user_id" => $this->user_id))->get();
                return $result;
	 }
	 
	/** GET USER LIST **/
	public function get_user_list()
	{               
                $result = $this->db->query("SELECT * FROM users WHERE  user_status = 1 ");	        
                return $result;
	}
	
	/** GET USER LIST **/
	public function get_transaction_list()
	{               
                $result = $this->db->query("SELECT * FROM transaction_mapping");
                return $result;
	}
	
	/** GET USER LIST **/
	public function get_transaction_chart_list()
	{	
	        $result = $this->db->from("transaction")
                                ->get();
                return $result;
               
	}
	 
	/** ADMINISTRATOR LOGIN **/
	
	public function admin_login($email = "", $password = "")
	{
		$result = $this->db->from("users")->where(array("email" => $email, "password" => md5($password), "user_type" => 1))->limit(1)->get();
		if(count($result) == 1){
			if($result->current()->user_status == 1){
				$this->session->set(array(
							"user_id" => $result->current()->user_id,
							"name" => $result->current()->firstname , 
							"user_email" => $result->current()->email, 
							"user_city" => $result->current()->city_id, 
							"user_type" =>  $result->current()->user_type,
							"facebook_status" =>  $result->current()->facebook_update,
							"fb_access_token" =>  $result->current()->fb_session_key,
							"fb_user_id" =>  $result->current()->fb_user_id
						));
						return 10;
			}
			return 9;
		}
		else{
			$emailCount = $this->db->count_records("users", array("email" => $email, "user_type" => 1));
			if($emailCount == 0){
				return 8;
			}
			return 0;
		}	
	}
	
	/** GET CITY DATA **/
	
	public  function getCityData($country , $city)
	{ 		 
		$result = $this->db->from("city")
			->join("country","country.country_id","city.country_id")
			->where(array("city.country_id" => $country, "city_url" => $city ))
			->limit(1)
			->get();
		return $result;
	}
	/** GET CITY LIST **/

	public function get_City_List()
	{
		$result = $this->db->from("city")
					->join("country","country.country_id","city.country_id")
					->where(array("city_status" => 1,"country.country_status" => 1))
					->orderby("city.city_name", "ASC")
					->get();
		return $result;
	}
	
	/** GET CITY LIST **/

	public function get_all_City_List()
	{
		$result = $this->db->from("city")
		            ->join("country","country.country_id","city.country_id")
					->orderby("city.city_name", "ASC")
					->get();
		return $result;
	}
		
	/** GET CITY LIST **/

	public function getCityList()
	{
		$result = $this->db->from("city")
					->join("country","country.country_id","city.country_id")
					->where(array("city_status" => 1))
					->orderby("city.city_name", "ASC")
					->get();
		return $result;
	}

	/** GET SINGLE ADMIN DATA **/
	
	public function get_users_data($userid = "")
	{
		$result = $this->db->from("users")->where(array("user_id" => $userid))->join("city","city.city_id","users.city_id")->limit(1)->get();
		return $result;
	}
		     
	/** ADD COUNTRY TO COUNTRY TABLE**/
	
	public function add_country($post="")
	{
		$result = $this->db->count_records("country", array("country_url" => url::title($post->country)));
		if($result == 0){
			$insert = $this->db->insert("country", array("country_name" => $post->country,"country_code" => $post->country_code, "country_url" => url::title($post->country),"currency_symbol" => $post->currency_symbol,"currency_code" => $post->currency_code));
			return count($insert);
		}
		return 0;
	}
	
	/** MANAGE COUNTRY DATA LIST **/
	
	public function getcountryDataList()
	{
		$result = $this->db->from("country")->orderby("country_url", "ASC")->get();
		return $result;
	}
	
	/** GET COUNTRY DATA **/
	
	public function getcountryData($country = "")
	{
		$result = $this->db->from("country")->where(array("country_url" => $country))->get();
		return $result;
	}
	
	/** EDIT COUNTRY **/
	
	public function edit_country($post = "", $country_url = "")
	{
		
		if(url::title($post->country) != $country_url){
			$result =  $this->db->count_records("country", array("country_url" => url::title($post->country)));
			if($result > 0){
				return 0;
			}
			
			//$status = $this->db->update("country", array("country_name" => $post->country, "country_url" => url::title($post->country),"currency_symbol" => $post->currency_symbol,"currency_code" => $post->currency_code),array("country_url" => $country_url));
		}
		$status = $this->db->update("country", array("country_name" => $post->country,"country_code"=>$post->country_code, "country_url" => url::title($post->country),"currency_symbol" => $post->currency_symbol,"currency_code" => $post->currency_code),array("country_url" => $country_url));
		if($status){
		return 1;
	}
	}
	
	/** DELETE COUNTRY **/
	
	public function deleteCountry($country = "")
	{
		$result = $this->db->delete("country",array("country_url" => $country ));
		return count($result);
	}
	
	/** BLOCK UNBLOCK COUNTRY **/
	
	public function blockunblockcountry($type = "", $country = "")
	{
		$status = 0;
		if($type == 1){
			$status = 1;
		}
		$result = $this->db->update("country", array("country_status" => $status),array("country_url" => $country));
		return count($result);
	}
	
	/** GET COUNTRY LIST **/
	
	public function get_country_list()
	{
		$result = $this->db->from("country")->where(array("country_status" => 1))->orderby("country_name", "ASC")->get();
		return $result;
	}
	
	/** ADD CITY TO DB **/
	
	public function add_city($country = "", $city = "",$post = "")
	{

		$result = $this->db->count_records("city", array("country_id" => $country , "city_url" => url::title($city)));
		if($result == 0){
			$addCity = $this->db->insert("city", array("country_id" => $country, "city_name" => $city, "city_url" => url::title($city),"city_latitude"=>$post->latitude,"city_longitude"=>$post->longtitude));
			return 1;
		}
		return 0;
	}
	
	/** EDIT CITY DATA **/
	
	public function edit_city($country = "", $city = "", $post = "")
	{

		if($country == $post["country"] && $city ==  url::title($post["city"]) ){
                $this->db->update("city", array("city_latitude" => $post["latitude"], "city_longitude" => $post["longtitude"]),array("country_id" => $country, "city_url" => $city));
			return 1;
		}
		$result = $this->db->count_records("city", array("city_url" => url::title($post["city"]), "country_id" => $post["country"]));


		if($result == 0){
			$this->db->update("city", array("country_id" => $post["country"] , "city_name" => $post["city"] ,"city_url" =>  url::title($post["city"]),"city_latitude" => $post["latitude"], "city_longitude" => $post["longtitude"]), 
			array("country_id" => $country, "city_url" => $city));
			return 1;
		}
                
                    
                    

		return 0;
	}
	  
	/** BLOCK OR UNBLOCK CITY **/
	
	public function blockunblockcity($type = "", $country = "", $city = "")
	{
		$status = 0;
		if($type == 1){
			$status = 1;
		}
		$result = $this->db->update("city", array("city_status" => $status), array("country_id" => $country, "city_url" => $city ));		
		return count($result);
	}
	
	/** DELETE CITY **/
	
	public function deleteCity($country = "", $city = "")
	{
		$result = $this->db->delete("city",array("country_id" => $country, "city_url" => $city));
		return count($result);
	}
	
	/** SET DEFAULT CITY **/
    
	public function default_city($city)
	{
		if($city){
		$city_update = $this->db->update("city", array("default" => 0), array("city_id >" => 0));
		}
		$result = $this->db->update("city", array("default" => 1), array("city_id" => $city));
		return 1;

	}	

		
	/** ADD CATEGORY **/
	
	public function add_category($category = "", $cat_status = "",$product = "")
	{
		$result = $this->db->count_records("category", array("category_url" => url::title($category)));
		if($result == 0){
			$status = $this->db->insert("category", array("category_name" => $category , "category_url" => url::title($category),"category_status" => $cat_status,"product" => $product));
                        if(count($status) == 1){
                                return $status->insert_id();
                        }
		}
		return 0;
	}

		/** ADD SUB CATEGORY **/
	
	public function add_sub_category($category = "", $cat_status = "",$cat_id = "")
	{
		$result = $this->db->count_records("category", array("category_url" => url::title($category)));
		if($result == 0){
			$status = $this->db->insert("category", array("category_name" => $category , "category_url" => url::title($category),"category_status" => $cat_status,"main_category_id" => $cat_id));
                        if(count($status) == 1){
                                return $status->insert_id();
                        }
		}
		return 0;
	}

	/** GET CATEGORY LIST **/
	
	public function get_category_list()
	{
		$result = $this->db->from("category")->orderby("category_name", "ASC")->get();
		return $result;
	}

	/** GET SUB CATEGORY LIST **/
	
	public function get_sub_category_list()
	{
		$result = $this->db->from("category")->where(array("main_category_id !=" =>0))->orderby("category_name", "ASC")->get();
		return $result;
	}
	/** GET SUB CATEGORY LIST **/
	
	public function get_sub_category_list1($cat_id = "")
	{
		$result = $this->db->from("category")->where(array("main_category_id" =>$cat_id))->orderby("category_name", "ASC")->get();
		return $result;
	}
	/** GET MAIN CATEGORY DATA **/
	
	public function get_category_data($cat_id = "", $cat_url = "")
	{
		$result = $this->db->from("category")->where( array("category_id" => $cat_id, "category_url" => url::title($cat_url)))->get();
		return $result;
	}

	/** GET MAIN SUB CATEGORY DATA **/
	
	public function get_sub_category_data($cat_id = "", $cat_url = "")
	{
		$result = $this->db->from("category")->where( array("category_id" => $cat_id, "category_url" => url::title($cat_url),"main_category_id !=" =>0))->get();
		return $result;
	}

	/** EDIT CATEGORY **/
	
	public function edit_category($category = "", $cat_status = "", $cat_id = "", $cat_url = "",$product = "")
	{
		if(url::title($category) != $cat_url){
			$result = $this->db->count_records("category", array("category_name" => url::title($category)));
			if($result > 0){
				return 0;
			}
		}
		$status = $this->db->update("category", array("category_name" => $category , "category_url" => url::title($category), "category_status" => $cat_status,"product" => $product),array("category_id" => $cat_id, "category_url" => url::title($cat_url)));
		return 1;	
	}
	

	
	/** BLOCK OR UNBLOCK CATEGORY **/
	
	public function blockunblockcategory($type = "", $cat_id = "", $cat_url = "")
	{
		$status = 0;
		if($type == 1){
			$status = 1;
		}
		$result = $this->db->update("category", array("category_status" => $status), array("category_id" => $cat_id, "category_url" => $cat_url ));
				$this->db->update("category", array("category_status" => $status), array("main_category_id" => $cat_id));		
		return count($result);
	}
	
	/** BLOCK OR UNBLOCK SUB CATEGORY **/
	
	public function blockunblocksubcategory($type = "", $main_cat_id, $cat_id = "", $cat_url = "")
	{
		$status = 0;
		if($type == 1){
			$status = 1;
		}
				$result = $this->db->from('category')->select('category_status')->where(array("category_id" => $main_cat_id,"main_category_id"=>0,"category_status" =>1))->get(); 
				if(count($result)>0){

		$result1 = $this->db->update("category", array("category_status" => $status), array("category_id" => $cat_id, "category_url" => $cat_url ));
				
				return count($result);
			}
			else return 0;
	}

	/** DELETE CATEGORY **/
	
	public function deleteCategory($cat_id = "", $cat_url = "")
	{
		$result = $this->db->delete("category",array("category_id" => $cat_id, "category_url" => $cat_url));
		return count($result);
	}

       /** ADMIN DETAILS **/
	
	public function user_details()
	{
		
		$result = $this->db->from("users")
				->where(array("user_id" =>$this->user_id))
                                ->join("city","city.city_id","users.city_id")
                                ->join("country","country.country_id","city.country_id")
                                ->get();
 
                return $result;
	}
 




       /** UPDATE ADMIN **/
	
        public function edit_admin($id = "",$post= "") 
        {
		$city_id=$post->city;
		$result_country = $this->db->select("country_id")->from("city")
					      ->where(array("city_id" =>$city_id))
				              ->limit(1)	
					      ->get();
		                               $country_value = $result_country->current()->country_id;

		$result = $this->db->update("users", array('firstname' => $post->name, 'email' => $post->email,'phone_number' => $post->mobile, 'address1' => $post->address1, 'address2' => $post->address2, 'city_id' => $post->city,'payment_account_id' => $post->payment,'country_id' =>$country_value), array('user_id' => $id));
		return $result;
        }



       /** UPDATE PASSWORD **/
    
	public function change_password($id = "", $pass = "")
	{
		$result = $this->db->update("users", array('password' => md5($pass->password)), array('user_id' => $id));
		return count($result);

	}


      /** CHECK PASSWORD **/
    
	public function exist_password($pass = "", $id = "")
	{
		$result = $this->db->count_records('users', array('user_id' => $id, 'password' => md5($pass)));
		return (bool) $result;
	}

	/** CHECK EMAIL EXIST **/ 

	public function exist_email($email = "")
	{
		$result = $this->db->count_records('users', array('email' => $email));
		return (bool) $result;
	}

	/** GET COPY RIGHTS**/

	public function get_copy_right()
	{
		$result = $this->db->from("cms")->where(array("cms_id" => 8))->get();
		return $result;
	}
	
	

	//** EMAIL SUBSCRIBER***//
	
	/** GET USERS DATA  **/
	
        public function get_subscriber_list($offset = "", $record = "",  $city= "",$email="")
        {

                	$contitions = "where email_subscribe.is_deleted=0";
			 if($city){
                                $contitions .= " AND find_in_set($city,email_subscribe.city_id)";
                        }

                        if($email){

		       // $contitions .= ' AND city.city_name like "%'.mysql_escape_string($city).'%"';
                        $contitions .= ' AND email_subscribe.email_id like "%'.mysql_escape_string($email).'%"';
                       
                        }	
 
                       $result = $this->db->query("select *,email_subscribe.city_id as city_ids from email_subscribe  join city on city.city_id=email_subscribe.city_id    $contitions  order by subscribe_id DESC limit $offset, $record");

                return $result;
        }
	
        /** GET USERS COMMANTS DATA  **/
	
        public function get_subscriber_count($city = "",$email="")
        {
               		$contitions = "where email_subscribe.is_deleted= 0";
                        if($city){
                                $contitions .= " AND find_in_set($city,email_subscribe.city_id)";
                        }

                        if($email){

		       // $contitions .= ' AND city.city_name like "%'.mysql_escape_string($city).'%"';
                        $contitions .= ' AND email_subscribe.email_id like "%'.mysql_escape_string($email).'%"';
                       
                        }	
                       $result = $this->db->query("select * from email_subscribe  join city on city.city_id=email_subscribe.city_id   $contitions  order by email_subscribe.subscribe_id DESC ");


                return count($result);
        }


	        
        /** BLOCK & UNBLOCK SUBSCRIBER**/
         
        public function block_subscriber($type="", $subscribe_id="")
        {
                $status = 0;
                if($type == 1){
                    $status = 1;
                }
                $result = $this->db->update("email_subscribe", array("suscribe_status" => $status), array("subscribe_id" => $subscribe_id));
                return count($result);
        }

	/** DELETE  SUBSCRIBER**/
	
	public function delete_subscriber($subscribe_id = "")
	{
		$result = $this->db->update("email_subscribe",array("is_deleted" => 1),array("subscribe_id" => $subscribe_id));
		return count($result);
	}


	/** GET CONTACTS DATA  **/
	
        public function get_contacts_list($offset = "", $record = "",  $name= "")
        {
                	$contitions = "where status=1";
                        if($name){
						$contitions .= ' AND name like "%'.mysql_escape_string($name).'%"';
                        $contitions .= ' OR email like "%'.mysql_escape_string($name).'%"';
                        }
                       $result = $this->db->query("select * from contact $contitions order by contact_id DESC  limit $offset, $record");
                return $result;
        }


	 /** GET CONTACTS DATA  **/
	
        public function get_contacts_count($name = "")
        {
               		$contitions = "where status=1";
                        if($name){

		        $contitions .= ' AND name like "%'.mysql_escape_string($name).'%"';
                        $contitions .= ' OR email like "%'.mysql_escape_string($name).'%"';
                        }	
                       $result = $this->db->query("select * from contact $contitions order by contact_id DESC "); 
                return count($result);
        }


	
	/** DELETE  SUBSCRIBER**/
	
	public function delete_contact($contact_id = "")
	{
		//$result = $this->db->delete('contact',array('contact_id' => $contact_id));
		$result = $this->db->update("contact",array("status" => 0),array("contact_id" => $contact_id));
		return count($result);
	}

	/** GET REFERRAL USERRS COUNT **/

	public function get_referral_users_count($name = "",$email = "")
	{
		$contitions = "u2.user_status = 1";
                        if($name){
                                $contitions .= ' AND u2.firstname like "%'.mysql_escape_string($name).'%" OR u1.firstname like "%'.mysql_escape_string($name).'%" ';
                        }

                        if($email){
		       // $contitions .= ' AND city.city_name like "%'.mysql_escape_string($city).'%"';
                        $contitions .= ' AND u2.email like "%'.mysql_escape_string($email).'%"';
                       
                        }	
                       $result = $this->db->query("select u1.firstname as refered_name,u2.firstname as referal_name,u2.joined_date as ref_joined_date,u2.email as ref_email from users as u1 join users as u2 on u2.referred_user_id = u1.user_id where $contitions  order by u2.joined_date DESC ");

                return count($result);
	}

	/** GET REFERRAL USERRS LIST **/

	public function get_referral_users_list($offset = "", $record = "",$name = "",$email = "")
	{
		$contitions = "u2.user_status = 1";
                        if($name){
                                $contitions .= ' AND u2.firstname like "%'.mysql_escape_string($name).'%" OR u1.firstname like "%'.mysql_escape_string($name).'%"';
                        }

                        if($email){

		       // $contitions .= ' AND city.city_name like "%'.mysql_escape_string($city).'%"';
                        $contitions .= ' AND u2.email like "%'.mysql_escape_string($email).'%"';
                        }
                       $result = $this->db->query("select u1.firstname as refered_name,u2.firstname as referal_name,u2.joined_date as ref_joined_date,u2.email as ref_email from users as u1 join users as u2 on u2.referred_user_id = u1.user_id where $contitions  order by u2.joined_date DESC limit $offset, $record  ");
                return $result;
	}

	/** ADD COLOR  **/
	
	public function add_color($color_code = "",$color_name = "")
	{ 
		$result = $this->db->insert("color_code",array("color_code" =>substr($color_code,1), "color_name" =>$color_name));
			return 1;
	}	

	/** GET COLOR COUNT  **/
	
	public function get_color_count()
	{
		return $this->db->count_records("color_code");
	}

	/** GET COLOR LIST  **/
	
	public function get_color_list($offset = "", $record = "")
	{
		return $this->db->limit($record,$offset)->get('color_code');

	}

	/** EDIT COLOR DATA AND UPDATE  **/

	public function edit_color($color_id = "",$color_code = "",$color_name = "")
	{
			$result =  $this->db->count_records("color_code", array("color_code" => $color_code));
			if($result > 0){
				return 0;
			}
			$status = $this->db->update("color_code", array("color_code" => substr($color_code,1), "color_name" => $color_name),array("id" => $color_id));
		return 1;

	}

	/** GET SINGLE COLO DATA FOR EDIT  **/

	public function getcolorData($color_id = "")
	{
		return $this->db->getwhere('color_code',array('id' => $color_id));
	}
	
	/** DELETE COLOR **/
	
	public function delete_color($color_id = "")
	{
		$result = $this->db->delete("color_code",array("id" => $color_id ));
		return count($result);
	}
	
	/** INSERT SIZE VALUE TO THE DATABASE */
	
	public function add_size($size = "")
	{
		$result = $this->db->insert("size",array("size_name" =>$size));
			return 1;
	}	
	
	
	/** GET SIZE COUNT  **/
	
	public function get_sizes_count()
	{
		return $this->db->count_records("size");
	}

	/** GET SIZE LIST  **/
	
	public function get_sizes_list($offset = "", $record = "")
	{
		return $this->db->get('size');
	}

	/** EDIT SIZE DATA AND UPDATE  **/

	public function edit_size($size_id = "",$size = "")
	{
			$result =  $this->db->count_records("size", array("size_name" =>$size));
			if($result > 0){
				return 0;
			}
			$status = $this->db->update("size", array("size_name" =>$size),array("size_id" => $size_id));
		return 1;

	}

	/** GET SINGLE COLO DATA FOR EDIT  **/

	public function getsizeData($size_id = "")
	{
		return $this->db->getwhere('size',array('size_id' => $size_id));
	}

	/** DELETE SIZE **/
	
	public function delete_size($size_id = "")
	{
		$result = $this->db->delete("size",array("size_id" => $size_id ));
		return count($result);
	}
	
	/** REGISTER  AUTO POST INTO FACEBOOK  WALL **/

	public function register_autopost($fb_profile = array(),$fb_access_token = "")
	{
        $result= $this->db->update("users", array("fb_user_id" => $fb_profile->id ,"fb_session_key" => $fb_access_token,"facebook_update"=>1), array("user_id" =>$this->user_id));   
		$this->session->set(array("fb_access_token" => $fb_access_token,"fb_user_id" => $fb_profile->id));
		return $result;
	}

	/** UPDATE  AUTO POST **/
	public function update_autopost($value = "")
	{	
		$result = $this->db->update("users", array("facebook_update" =>$value,"fb_user_id"=>0,"fb_session_key"=>0), array("user_id" =>$this->user_id));
		return $result;
	}


}

