<?php defined('SYSPATH') or die('No direct script access.');
class Admin_products_Model extends Model
{
	public function __construct()
	{	
		parent::__construct();
		$this->db = new Database();
		$this->session = Session::instance();	
	}

	/** GET PRODUCTS CATEGORY LIST **/
	
	public function get_category_list()
	{
		$result = $this->db->from("category")->where(array("category_status" => 1,"main_category_id"=>0))->orderby("category_name","ASC")->get();
		return $result;
	}

	/** GET PRODUCTS SUB CATEGORY LIST **/
	
	public function get_sub_category_list()
	{
		$result = $this->db->from("category")->where(array("category_status" => 1,"main_category_id !="=>0))->orderby("category_name","ASC")->get();
		return $result;
	}
	
	 /** GET SUB CATEGORY LIST BY CATEGORY **/
	public function get_sub_category($category = "")
	{ 
	    $result = $this->db->from("category")
						   ->where(array("main_category_id" => $category, "category_status" => 1))
					   ->orderby("category_name")->get();
	    return $result;
	}


	/** GET CITY LIST **/
	
	public function get_city_list()
	{
		$result = $this->db->from("city")->join("country","country.country_id","city.country_id")->where(array("city_status" => 1,"country_status" => 1))->orderby("city_name","ASC")->get();
		return $result;
	}

     /** GET PRODUCT COLOR **/
	
	public function store_color_data($city_id = "",$deal_id = "")
	{
	    $dealdata = $this->db->select("color_id")->from("color")->where(array("deal_id" => $deal_id,"color_code_id" => $city_id))->get();
	    if(count($dealdata) == 1){	    
	        return 0;
	    } else {
	    
	    $result_id = $this->db->select("color_code","color_name")->from("color_code")->where(array("id" => $city_id))->get();
		$result = $this->db->insert("color", array("deal_id" => $deal_id,"color_code_id" => $city_id,"color_name" => $result_id->current()->color_code,"color_code_name" => $result_id->current()->color_name));
		
		return 1;
		}
	}
	
	   
	/** ADD PRODUCTS **/
	
	public function add_product($post = "", $deal_key = "",$adminid = "",$size_quantity = "")
	{
	
	    $quantity = "";
	    foreach($size_quantity as $sq){
	      $quantity += $sq;
	    }
		$sub_cat1 = $_POST['sub_category'];	 //Multiple stores have same deal          
		$sub_cat = implode(',',$sub_cat1);
		$shipping_amount ="";			
		$savings=($post->price-$post->deal_value);
		$result = $this->db->insert("product", array("deal_title" => $post->title, "url_title" => url::title($post->title), "deal_key" => $deal_key, "deal_description" => $post->description, "category_id" => $post->category,"sub_category_id" => $sub_cat, "deal_type"=> $post->deal_type, "deal_price" => $post->price,"deal_value" => $post->deal_value,"deal_savings" => $savings,"meta_keywords" => $post->meta_keywords , "meta_description" =>  $post->meta_description,"deal_percentage" => ($savings/$post->price)*100,"created_date" => time(),"created_by"=>$adminid,"color" => $post->color_val,"size" => $post->size_val,"user_limit_quantity"=>$quantity,"deal_status" =>0));
	
	    $product_id = $result->insert_id();
	    if(($post->color_val) == 1){
	        foreach($post->color as $c){
	            $result_count = $this->db->from("color")->where(array("deal_id" => $product_id, "color_name" => $c))->get();
	            if(count($result_count)==0){	      
	            $result_id = $this->db->from("color_code")->where(array("color_code" => $c))->get();      
	            $result_color = $this->db->insert("color", array("deal_id" => $product_id, "color_name" => $c, "color_code_id" => $result_id->current()->id,"color_code_name" => $result_id->current()->color_name));
	            }
	        } 
	    }   
	    
	    if(($post->size_val) == 1){
	        $i= 0;
	        foreach($post->size as $s){
	            $result_count = $this->db->from("product_size")->where(array("deal_id" => $product_id, "size_id" => $s))->get();
	            if(count($result_count)==0){	  
	            $result_id = $this->db->from("size")->where(array("size_id" => $s))->get();        
	            $result_color = $this->db->insert("product_size", array("deal_id" => $product_id, "size_name" => $result_id->current()->size_name, "size_id" => $s,"quantity"=>$size_quantity[$i]));
	            $i++; }
	        } 
	    }   
	    
		if(count($result) == 1){
				foreach($sub_cat1 as $s){
					$this->db->insert('category_mapping',array('category_map_deal_id' => $result->insert_id(),'map_category_id' => $s,"map_main_category_id" => $post->category,"category_type" => 2));
				}
			return $result->insert_id();
		}
		return 0;
          
	}
	
        /** CHECK TITLE EXIST **/ 
	
	public function exist_title($title = "")
	{
		$result = $this->db->count_records('product', array('deal_title' => $title));
		return (bool) $result;
	}
	
	/** MANAGE  PRODUCTS **/
	
	public function get_all_products_list($type = "",$offset = "", $record = "", $name = "",$sort_type = "",$param = "")
	{ 
	    $sort = "ASC";
		if($sort_type == "DESC" ){
			$sort = "DESC";
		}		
		if($_GET){  
		        if($type != "1")
		        {
		                $conditions = "purchase_count < user_limit_quantity ";
		        } else {

		                $conditions = "purchase_count >= user_limit_quantity ";
		        }
                        
			if($name){
			$conditions .= " and deal_title like '%".mysql_escape_string($name)."%'";
			}

			$sort_arr = array("name"=>" order by product.deal_title $sort","price"=>" order by product.deal_price $sort","value"=>" order by product.deal_value $sort","savings"=>" order by product.deal_savings $sort");

			if(isset($sort_arr[$param])){
	       		 $conditions .= $sort_arr[$param];
	        	}else{  $conditions .= ' order by product.deal_id DESC'; }
			
			$query = "select * from product join category on category.category_id=product.category_id where $conditions  limit $offset,$record";
			$result = $this->db->query($query);
		}
		else{		
		
		       if($type != "1")
		        {
		                $conditions = "purchase_count < user_limit_quantity ";
		        }else {
		                $conditions = "purchase_count >= user_limit_quantity ";
		        }

			$sort_arr = array("name"=>" order by product.deal_title $sort","price"=>" order by product.deal_price $sort","value"=>" order by product.deal_value $sort","savings"=>" order by product.deal_savings $sort");

			if(isset($sort_arr[$param])){
	       		 $conditions .= $sort_arr[$param];
	        	}else{  $conditions .= ' order by product.deal_id DESC'; }
			
			$query = "select * from product join category on category.category_id=product.category_id where $conditions limit $offset,$record";
			$result = $this->db->query($query);
		} 
		return $result;
	}
	
	/** PRODUCTS COUNT **/
	
	public function get_all_products_count($type = "", $name = "",$sort_type = "",$param = "")
	{
			$sort = "ASC";
			if($sort_type == "DESC" ){
				$sort = "DESC";
			}
            if($_GET){ 
	
                if($type != "1")
	        {
	            $conditions = "purchase_count < user_limit_quantity ";
	        }else {
	            $conditions = "purchase_count >= user_limit_quantity ";
	        }

			if($name){
				$conditions .= " and deal_title like '%".mysql_escape_string($name)."%'";
			}

			$sort_arr = array("name"=>" order by product.deal_title $sort","price"=>" order by product.deal_price $sort","value"=>" order by product.deal_value $sort","savings"=>" order by product.deal_savings $sort");

			    if(isset($sort_arr[$param])){
	       		        $conditions .= $sort_arr[$param];
	        	}else{  $conditions .= ' order by product.deal_id DESC'; }
	        	
			$query = "select product.deal_id from product join category on category.category_id=product.category_id where $conditions";
			$result = $this->db->query($query);
                } else {
                
			    if($type != "1")
		        {
		                $conditions = "purchase_count < user_limit_quantity ";
		        }else {
		                $conditions = "purchase_count >= user_limit_quantity ";
		        }
			
			$sort_arr = array("name"=>" order by product.deal_title $sort","price"=>" order by product.deal_price $sort","value"=>" order by product.deal_value $sort","savings"=>" order by product.deal_savings $sort");

			if(isset($sort_arr[$param])){
	       		 $conditions .= $sort_arr[$param];
	        	}else{  $conditions .= ' order by product.deal_id DESC'; } 

			$query = "select product.deal_id from product join category on category.category_id=product.category_id where $conditions";
			$result = $this->db->query($query);
                }
		
                return count($result);
	}
	
	/** VIEW PRODUCTS **/
	
	public function get_product_data($deal_key = "", $deal_id = "")
	{
	        $result = $this->db->from("product")
	                        ->where(array("deal_id" => $deal_id, "deal_key" => $deal_key))
				->join("category","category.category_id","product.category_id")
 	                        ->get();
                return $result;
	}
	
	/* GET CITY BY SHIPPING */
	public function get_city_by_shipping($store_id = "")
	{
	$result = $this->db->select("city.shipping_amount")->from("stores")	                
	                    ->where(array("store_id" => $store_id))
	                    ->join("city","city.city_id","stores.city_id")
	                    ->get();
		return $result;
	}
	
	
	/** GET PRODUCT COLOR **/
	
	public function get_product_color($deal_id = "")
	{
		$result = $this->db->from("color")
				->where(array("deal_id" => $deal_id))
		     		->get();
		return $result;
	}
	
	/** GET PRODUCT COLOR  CODE **/
	
	public function get_color_code()
	{
		$result = $this->db->from("color_code")
		     		->get();
		return $result;
	}
	
	
	/** GET PRODUCT COLOR **/
	
	public function get_color_data($color_id="")
	{
		$result = $this->db->from("color_code")
		                ->where(array("id" => $color_id))
		     		->get();
		return $result;
	}
	
	
	/** GET PRODUCT SIZE **/
	
	public function get_product_size()
	{
		$result = $this->db->from("size")->orderby('size_name','DESC')
		     		->get();
		return $result;
	}
	
	
	/** GET PRODUCT SIZE **/
	
	public function get_size_data($size_id="")
	{
		$result = $this->db->from("size")
		                ->where(array("size_id" => $size_id))
		     		->get();
		return $result;
	}
	
	/** GET PRODUCT SIZE **/
	
	public function get_product_one_size($deal_id = "")
	{
		$result = $this->db->from("product_size")
				->where(array("deal_id" => $deal_id))
		     		->get();
		return $result;
	}
	
	
	/** GET PRODUCT COLOR **/
	
	public function store_size_data($city_id = "",$deal_id = "")
	{
	    $dealdata = $this->db->select("product_size_id")->from("product_size")->where(array("deal_id" => $deal_id,"size_id" => $city_id))->get();
	    if(count($dealdata) == 1){	    
	        return 0;
	    } else {
	    
	    $result_id = $this->db->select("size_name")->from("size")->where(array("size_id" => $city_id))->get();
		$result = $this->db->insert("product_size", array("deal_id" => $deal_id,"size_id" => $city_id,"size_name" => $result_id->current()->size_name));
		
		return 1;
		}
	}
	
	/** EDIT PRODUCT DATA **/
	
	public function get_edit_product($deal_id = "",$deal_key = "")
	{
		$result = $this->db->from("product")
				->where(array("deal_id" => $deal_id, "deal_key" => $deal_key))
		     		->get();
		return $result;
	}
	
	/** UPDATE PRODUCTS **/
	
	public function edit_product($deal_id = "", $deal_key = "", $post = "",$size_quantity = "")
	{ 
	     $quantity = "";
	    foreach($size_quantity as $sq){
	      $quantity += $sq;
	    }
		$sub_cat1 = $_POST['sub_category'];	 //Multiple stores have same deal          
		$sub_cat = implode(',',$sub_cat1);
		$dealdata = $this->db->select("deal_title","url_title")->from("product")->where(array("deal_id" => $deal_id, "deal_key" => $deal_key))->get();
		if(count($dealdata) == 1){			
			
			$oldurlTitle = $dealdata->current()->url_title;
			if($oldurlTitle != url::title($post->title)){	
				$result = $this->db->count_records("product", array("url_title" => url::title($post->title)));
				if($result > 0){
					return 0;
				}
			}
			 
			$result = $this->db->delete('color', array('deal_id' => $deal_id));
			$result = $this->db->delete('product_size', array('deal_id' => $deal_id));
			$savings=($post->price-$post->deal_value);
			    $shipping_amount = $post->shipping_amount;
			
			$this->db->update("product", array("deal_title" => $post->title, "url_title" => url::title($post->title), "deal_key" => $deal_key, "deal_description" => $post->description, "category_id" => $post->category,"sub_category_id" => $sub_cat, "deal_price" => $post->price,"deal_value" => $post->deal_value,"deal_savings" =>$savings,"meta_keywords" => $post->meta_keywords , "meta_description" =>  $post->meta_description,"deal_percentage" => ($savings/$post->price)*100,"color" => $post->color_val,"size" => $post->size_val,"shipping_amount" => $shipping_amount,"user_limit_quantity"=>$quantity), array("deal_id" => $deal_id, "deal_key" => $deal_key));

            if(($post->color_val) == 1){
			foreach($post->color as $c){
			     $result_id = $this->db->from("color_code")->where(array("color_code" => $c))->get();	            
	            $result_color = $this->db->insert("color", array("deal_id" => $deal_id, "color_name" => $c, "color_code_id" => $result_id->current()->id,"color_code_name" => $result_id->current()->color_name));
	        }
	        }
	        
	        if(($post->size_val) == 1){
	        $i= 0;
	        foreach($post->size as $s){  
	            $result_id = $this->db->from("size")->where(array("size_id" => $s))->get();        
	            $result_color = $this->db->insert("product_size", array("deal_id" => $deal_id, "size_name" => $result_id->current()->size_name, "size_id" => $s,"quantity"=>$size_quantity[$i]));	          
	        $i++; }
	        }
			/* Multiple category mapping  */
			$this->db->delete("category_mapping",array("category_map_deal_id" => $deal_id,"category_type" => 2));
			foreach($sub_cat1 as $s){
					$this->db->insert('category_mapping',array('category_map_deal_id' => $deal_id,'map_category_id' => $s,"map_main_category_id" => $post->category,"category_type" => 2));
				}

			return 1;
		}
		return 8;
	}

	/** BLOCK UNBLOCK PRODUCTS **/
	
	public function blockunblockproduct($type = "", $key = "", $deal_id = "" )
	{  
		$status = 0;
		if($type == 1){
		$status = 1;
		}
		$result = $this->db->update("product", array("deal_status" => $status), array("deal_id" => $deal_id, "deal_key" => $key));
		return count($result);
	}
	
	/** GET CATEGORY LIST **/
	
	public function all_category_list()
	{
		$result = $this->db->from("category")->get();
		return $result;
	}
	
        /** GET MARCHANT LIST **/
        
	public function getmarchantlist()
        { 

		$result = $this->db->from("users")->where(array("user_type" => '3',"user_status"=> '1'))->orderby("firstname")->get();
		return $result;
        }
	
         /** GET SHOP LIST **/
         
	public function get_shop_list()
        {
                $result = $this->db->from("stores")
                            ->join("users","users.user_id","stores.merchant_id")
                            ->orderby("stores.store_name", "ASC")
                            ->where(array("store_status" => '1'))
                            ->get();
                return $result;
        }
        
        /** GET CITY LIST **/
   	public function get_city_lists()
        {
                $result = $this->db->from("city")
			    ->join("country","country.country_id","city.country_id")
                            ->orderby("city.city_name", "ASC")
                            ->where(array("city_status" => '1',"country.country_status"=>1))
                            ->get();
                return $result;
        }
        
        
        /** GET STORE LIST BY USER **/
        public function get_store_by_users($users = "")
	{
		$result = $this->db->from("stores")->where(array("user_id" => $users, "store_status" => '1',"city.city_status" => '1'))
		->join("city","city.city_id","stores.city_id")
		->join("users","users.user_id","stores.merchant_id")
		->orderby("store_name")->get();
		return $result;
	} 
	
        /** GET USER LIST **/
        
	public function getdeallist()
        {
                $result = $this->db->from("product")
                            ->orderby("deal_title", "ASC")
                            ->where(array("deal_status" => '1'))
                            ->get();
                return $result;
        }
        
        /** VIEW PRODUCT FOR TRANSACTION**/
	
	public function get_transaction_data($deal_id = "")
	{
                $result = $this->db->from("product")
                                ->where(array("transaction.product_id" => $deal_id,"transaction.type !=" =>5))
	                        	->join("transaction","transaction.product_id","product.deal_id")
                                ->get();
                return $result;
	}
	
	 /** VIEW PRODUCT FOR TRANSACTION**/
	
	public function get_cod_transaction_data($deal_id = "")
	{
                $result = $this->db->from("product")
                                ->where(array("transaction.product_id" => $deal_id,"transaction.type" =>5))
	                        	->join("transaction","transaction.product_id","product.deal_id")
                                ->get(); 
                return $result;
	}
	
	/** GET MERCHANT BALANCE **/
	
	public function get_merchant_balance()
	{
		$result =$this->db->from("users")->where(array("user_type" => 3))->get();
		return $result;
	 } 
	 
	 
	 /** GET USER LIST **/
	public function get_transaction_chart_list()
	{	
	        $result = $this->db->from("transaction_mapping")
	                            ->join("product","product.deal_id","transaction_mapping.product_id")
                                ->get();
                return $result;
               
	}
	
	public function get_deals_chart_list()
	{	
	    $result_active_products = $this->db->query("SELECT * FROM product  WHERE purchase_count < user_limit_quantity and deal_status = 1 ");
		$result["active_products"]=count($result_active_products);
		
		$result_sold_products =$this->db->query("SELECT * FROM product WHERE purchase_count = user_limit_quantity and deal_status = 1 ");
		$result["archive_products"]=count($result_sold_products);
		return $result;
	}
	
	/** GET PRODUCT LIST  **/
	
        public function get_users_comments_list($offset = "", $record = "",  $firstname = "",$deal_type = "")
        {
                $contitions = "discussion.type = $deal_type ";
                        if($firstname){
                        $contitions .= ' AND (users.firstname like "%'.mysql_escape_string($firstname).'%"';
                        $contitions .= 'OR product.deal_title like "%'.mysql_escape_string($firstname).'%"';
                        $contitions .= 'OR discussion.comments like "%'.mysql_escape_string($firstname).'%")';
                        }
                       $result = $this->db->query("select *, discussion.created_date as dis_create from discussion join users on users.user_id=discussion.user_id join product on product.deal_id=discussion.deal_id where $contitions order by discussion_id DESC limit $offset, $record");
                return $result;
        }
	
        /** GET PRODUCT COMMENTS COUNT  **/
	
        public function get_users_comments_count($firstname = "",$deal_type = "")
        {
               $contitions = "discussion.type = $deal_type ";
                        if($firstname){
                        $contitions .= ' AND (users.firstname like "%'.mysql_escape_string($firstname).'%"';
                        $contitions .= 'OR product.deal_title like "%'.mysql_escape_string($firstname).'%"';
                        $contitions .= 'OR discussion.comments like "%'.mysql_escape_string($firstname).'%")';
                        }
                       $result = $this->db->query("select *, discussion.created_date as dis_create from discussion join users on users.user_id=discussion.user_id join product on product.deal_id=discussion.deal_id where $contitions order by discussion_id DESC");
                return count($result);
        }
		 /** GET SINGLE PRODUCT COMMENTS DATA **/
	
	public function get_users_comments_data($discussionid = "")
	{
		$result = $this->db->from("discussion")->where(array("discussion_id" => $discussionid))->join("product","product.deal_id","discussion.deal_id")->limit(1)->get();
		return $result;
	}
        
        /** UPDATE PRODUCT COMMENTS**/
	
        public function edit_users_comments($commentsid = "",$post = "") 
        {
                $result = $this->db->update("discussion", array("comments" => $post->comments, "created_date"=>time()), array("discussion_id" => $commentsid));
                return 1;
        }
        
        /** BLOCK & UNBLOCK PRODUCT COMMENTS**/
         
        public function blockunblockusercomments($type = "", $commentsid = "")
        {
                $status = 0;
                if($type == 1){
                    $status = 1;
                }
                $result = $this->db->update("discussion", array("discussion_status" => $status), array("discussion_id" => $commentsid));
                return count($result);
        }

		/** DELETE PRODUCT COMMENT  **/
		
		public function deleteusercomments($discussion_id = "")
		{
			$result = $this->db->delete('discussion', array('discussion_id' => $discussion_id));
					  $this->db->delete('discussion_likes', array('discussion_id' => $discussion_id));
					  $this->db->delete('discussion_unlike', array('discussion_id' => $discussion_id));
			return count($result);

		}		

		/** GET SHIPPING DATA  **/
		/**   s->shipping_info,t->transaction,u->user,tm->transaction_mapping    **/
	
        public function get_shipping_list($offset = "", $record = "",  $name= "",$type = "")
        {	
				$condition = "AND t.type != 5";
				
				if($type){
					$condition = " AND t.type = 5 ";
					
				}
        		if($_GET){
	        		$contitions = ' (u.firstname like "%'.mysql_escape_string($name).'%"';
                    $contitions .= 'OR u.email like "%'.mysql_escape_string($name).'%"';
            		$contitions .= 'OR tm.coupon_code like "%'.mysql_escape_string($name).'%")';
                   $result = $this->db->query("select *,s.adderss1 as saddr1,s.address2 as saddr2,u.phone_number,t.id as trans_id,t.shipping_amount as shipping from shipping_info as s join transaction as t on t.id=s.transaction_id join product as d on d.deal_id=t.product_id join transaction_mapping as tm on tm.transaction_id = t.id join city on city.city_id=s.city join users as u on u.user_id=s.user_id where $contitions and shipping_type = 1 $condition group by shipping_id order by shipping_id DESC  limit $offset, $record "); 
				}
				else {
					$result = $this->db->query("select *,s.adderss1 as saddr1,s.address2 as saddr2,u.phone_number,t.id as trans_id,t.shipping_amount as shipping from shipping_info as s join transaction as t on t.id=s.transaction_id join product as d on d.deal_id=t.product_id join transaction_mapping as tm on tm.transaction_id = t.id join city on city.city_id=s.city join users as u on u.user_id=s.user_id  where shipping_type = 1 $condition group by shipping_id order by shipping_id DESC  limit $offset, $record"); 
				}
            
                return $result;
        }

		 /** GET CONTACTS DATA  **/
		/**   s->shipping_info,t->transaction,u->user,tm->transaction_mapping     **/
	
        public function get_shipping_count($name = "",$type = "")
        {
				$condition = "AND t.type != 5";
				
				if($type){
					$condition = " AND t.type = 5 ";
				}
           		if($_GET){
			        $contitions = ' (u.firstname like "%'.mysql_escape_string($name).'%"';
                    $contitions .= ' OR u.email like "%'.mysql_escape_string($name).'%"';
					$contitions .= 'OR tm.coupon_code like "%'.mysql_escape_string($name).'%")';
                   
                   $result = $this->db->query("select s.shipping_id from shipping_info as s join transaction as t on t.id=s.transaction_id join product as d on d.deal_id=t.product_id join transaction_mapping as tm on tm.transaction_id = t.id join city on city.city_id=s.city join users as u on u.user_id=s.user_id where $contitions and shipping_type = 1 $condition group by shipping_id order by shipping_id DESC "); 
		}
		else {
			$result = $this->db->query("select s.shipping_id from shipping_info as s join transaction as t on t.id=s.transaction_id join product as d on d.deal_id=t.product_id join transaction_mapping as tm on tm.transaction_id = t.id join city on city.city_id=s.city join users as u on u.user_id=s.user_id where shipping_type = 1 $condition group by shipping_id order by shipping_id DESC"); 
		}
                return count($result);
        }

	public function update_shipping_status($id = "")
	{
		$result = $this->db->update('shipping_info',array('delivery_status' => 1),array('shipping_id' => $id ,'shipping_type' => 1)); 
		return count($result);
	}

	public function get_shipping_product_color()
	{
		$result = $this->db->from("color_code")->get();
		return $result;
	}
	
	public function get_shipping_product_size()
	{
		$result = $this->db->from("size")->get();
		return $result;
	}

	public function validate_coupon($coupon = "",$product_amount = "",$trans_id = "")
	{ 
		$result =  $this->db->count_records("transaction_mapping", array("coupon_code" => $coupon,"transaction_id" => $trans_id,"coupon_code_status" =>1)); 
			if($result > 0){
				//$this->db->query("update users set merchant_account_balance = merchant_account_balance + $product_amount where user_type = 1");
				$this->db->update('transaction',array('captured' => 1,'captured_date' =>time(),'payment_status' => 'Completed','pending_reason' =>'None'),array('id' => $trans_id));

				$this->db->update('transaction_mapping',array('coupon_code_status' => 0),array("transaction_id" => $trans_id));
				return 1;
			}
	
			else return 0;
	}	
	
	/*	GET POPULAR PRODUCT LIST */
	public function get_popular_product_list($product_id="",$type="")
	{
		
		$result= $this->db->update('product',array('deal_feature' => $type),array("deal_id" => $product_id));
		return 1;
	}
	/** GET SINGLE USER DATA **/
	
	public function get_users_data($userid = "")
	{
		$result = $this->db->from("users")->where(array("user_type" => $userid))->where('user_status',1)->get(); 
		return $result;
	}
}
